﻿using Microsoft.EntityFrameworkCore.Diagnostics;
using SchoolScheduleContracts.BusinessLogicsContracts;
using SchoolScheduleContracts.SearchModels;
using SchoolScheduleDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SchoolSchedule
{
	public partial class LessonForm : Form
	{
		public ILessonModel Lesson { get; set; } = null;
		IStudentLogic _logic;
		public LessonForm(IStudentLogic logic)
		{
			_logic = logic;
			InitializeComponent();
			LoadData();
		}
		public void LoadData()
		{
			if (Lesson != null)
			{
				var students = _logic.ReadList(new StudentSearchModel { GradeId = Lesson.GradeId });
				foreach (var student in students)
				{
					dataGridView1.Rows.Clear();
					dataGridView1.Rows.Add(new object[] { student.FullName, student.Attendance[Lesson.Id].Item2, student.Attendance[Lesson.Id].Item3 });
				}
			}
		}
	}
}
