﻿using SchoolScheduleContracts.BindingModels;
using SchoolScheduleContracts.BusinessLogicsContracts;
using SchoolScheduleContracts.SearchModels;
using SchoolScheduleContracts.StoragesContracts;
using SchoolScheduleContracts.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SchoolScheduleBusinessLogic
{
	public class TeacherLogic : ITeacherLogic
	{
		private readonly ITeacherStorage _teacherStorage;
		public TeacherLogic(ITeacherStorage teacherStorage)
		{
			_teacherStorage = teacherStorage;
		}

		public List<TeacherViewModel> ReadList(TeacherSearchModel? model)
		{
			var list = model == null ? _teacherStorage.GetFullList() :
_teacherStorage.GetFilteredList(model);
			return list;
		}

		public TeacherViewModel? ReadElement(TeacherSearchModel model)
		{
			if (model == null)
			{
				throw new ArgumentNullException(nameof(model));
			}
			var element = _teacherStorage.GetElement(model);
			return element;
		}
		public bool Create(TeacherBindingModel model)
		{
			if (_teacherStorage.Insert(model) == null)
			{
				return false;
			}
			return true;
		}
		public bool Update(TeacherBindingModel model)
		{
			if (_teacherStorage.Update(model) == null)
			{
				return false;
			}
			return true;
		}
		public bool Delete(TeacherBindingModel model)
		{
			if (_teacherStorage.Delete(model) == null)
			{
				return false;
			}
			return true;
		}
	}
}
