﻿using SchoolScheduleContracts.BindingModels;
using SchoolScheduleContracts.ViewModels;
using SchoolScheduleDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics.Metrics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SchoolScheduleDataBaseImplement.Models
{
	public class Subject : ISubjectModel
	{
		public int Id { get; private set; }
		[Required]
		public string SubjectName { get; private set; } = string.Empty;
		[ForeignKey("SubjectId")]
		public virtual List<Lesson> Lessons { get; set; } = new();

		public static Subject? Create(SchoolScheduleDataBase context, SubjectBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new Subject()
			{
				Id = model.Id,
				SubjectName = model.SubjectName,
			};
		}
		public void Update(SchoolScheduleDataBase context, SubjectBindingModel model)
		{
			SubjectName = model.SubjectName;
		}
		public SubjectViewModel GetViewModel => new()
		{
			Id = Id,
			SubjectName = SubjectName
		};
	}
}
